	LIST p=PIC16F648A
	#include P16F648A.INC
	__config 0x2141
;===============================
	COUNTER equ 0x20
;-----------------
;*** Bin to BCD Regs *****
	cblock 0x21
	BCD_DT
	BCD_T
	BCD_H
	BCD_D
	BCD_U
	BCD1
	BCD2
	BCD3
	BIN_HI
	BIN_LO
	CTR
	endc
;===============================
;--       --
	Define_PrimeNumber macro PrNum
		movlw PrNum
		xorwf COUNTER, W
		btfsc STATUS, Z
		bsf PORTA, 2
		nop
	endm	
;===============================
	org 0x00
	goto Initial_PIC
	org 0x05
;===============================
Initial_PIC:
	movlw b'00000011'
	movwf PORTA
	clrf PORTB
	clrf TMR1H
	clrf TMR1L
	clrf BCD_U
	clrf BCD_D
;- Set Timer 1 ---
	movlw 0x20
	movwf T1CON
;- Set I/O Port --
	bsf STATUS, RP0
	movlw 0x07
	movwf CMCON
	comf TRISB
	comf TRISA
	bcf STATUS, RP0
;--
	bsf T1CON, TMR1ON		;  1
;===============================
Work:
	clrf COUNTER
Cycle:
	bcf PORTA, 2			; 
;-- Dinamic Indication ----------
Din_Ind:
	clrf PORTB				; 
	bsf PORTA, 0			; 
	bcf PORTA, 1			;
	movf BCD_U, W
	call Display			;
	movwf PORTB				; 
	call DefPrNum			;  
	call bin2bcd
;--
	clrf PORTB				; 
	bsf PORTA, 1			; 
	bcf PORTA, 0			;
	movf BCD_D, W
	call Display
	movwf PORTB				; 
	call DefPrNum			;  
	call bin2bcd
;-- Detect 1 sec ----------------
	btfss PIR1, TMR1IF		;  1 
	goto Din_Ind			;  
;--------------------------------
;-- Increment Counter
	bcf PIR1, TMR1IF		;   1
	incf COUNTER			; 
	movlw .100				; ..
	xorwf COUNTER, W		;....
	btfss STATUS, Z			;.. 100
	goto Cycle				;   .
	goto Work				;  
;--------------------------------
;--------------------------------
;- List of Prime Numbers	;  
DefPrNum:
	Define_PrimeNumber .2
	Define_PrimeNumber .3
	Define_PrimeNumber .5
	Define_PrimeNumber .7
	Define_PrimeNumber .11
	Define_PrimeNumber .13
	Define_PrimeNumber .17
	Define_PrimeNumber .19
	Define_PrimeNumber .23
	Define_PrimeNumber .29
	Define_PrimeNumber .31
	Define_PrimeNumber .37
	Define_PrimeNumber .41
	Define_PrimeNumber .43
	Define_PrimeNumber .47
	Define_PrimeNumber .53
	Define_PrimeNumber .59
	Define_PrimeNumber .61
	Define_PrimeNumber .67
	Define_PrimeNumber .71
	Define_PrimeNumber .73
	Define_PrimeNumber .79
	Define_PrimeNumber .83
	Define_PrimeNumber .89
	Define_PrimeNumber .97
	return
;----------------------------------
;-- Display Table ----------------
Display:
	addwf PCL
	dt 0x3F, 0x06, 0x5B, 0x4F, 0x66
	dt 0x6D, 0x7D, 0x07, 0x7F, 0x6F
	return
;----------------------------------
;-- Convert Binary to BCD ---------
bin2bcd:
	clrf BIN_HI
	movf COUNTER, W
	movwf BIN_LO

	swapf BIN_HI, W 
	andlw 0x0F
	addlw 0xF0  
	movwf BCD_T 
	addwf BCD_T 
	addlw 0xE2
	movwf BCD_H 
	addlw 0x32
	movwf BCD_U 	
	movf BIN_HI, W 
	andlw 0x0F 
	addwf BCD_H 
	addwf BCD_H 
	addwf BCD_U
	addlw 0xE9 
	movwf BCD_D 
	addwf BCD_D  
	addwf BCD_D 	
	swapf BIN_LO, W 
	andlw 0x0F 
	addwf BCD_D 
	addwf BCD_U	               
	rlf BCD_D 
	rlf BCD_U  
	comf BCD_U  
	rlf BCD_U	               
	movf BIN_LO, W 
	andlw 0x0F 
	addwf BCD_U  
	rlf BCD_T	               
	movlw 0x07 
	movwf BCD_DT 
	movlw 0x0A
	addwf BCD_U
	decf BCD_D 
	btfss STATUS, C 
	goto $-3
	addwf BCD_D 
	decf BCD_H 
	btfss STATUS, C 
	goto $-3 
	addwf BCD_H 
	decf BCD_T 
	btfss STATUS, C  
	goto $-3 
	addwf BCD_T
	decf BCD_DT 
	btfss STATUS, C  
	goto $-3 
    return
;--------------------------------
;================================
	end